package ca.mcgill.cs.swevo.diffcat.view;

import java.util.ArrayList;

@SuppressWarnings({"unchecked", "rawtypes"})
class TreeParent extends TreeObject {
	private ArrayList children;
	
	public TreeParent(String name) {
		super(name);
		children = new ArrayList();
	}
	
	public void addChild(TreeObject child) {
		children.add(child);
		child.setParent(this);
	}
	
	public void removeChild(TreeObject child) {
		children.remove(child);
		child.setParent(null);
	}
	
	public TreeObject [] getChildren() {
		return (TreeObject [])children.toArray(new TreeObject[children.size()]);
	}
	
	public void clearChildren () {
		children.clear();
	}
	
	public boolean hasChild (TreeObject child) {
		return children.contains(child);
	}
	
	public boolean hasChildren() {
		return children.size()>0;
	}
}
