package ca.mcgill.cs.swevo.diffcat.view.actions;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;

import ca.mcgill.cs.swevo.diffcat.view.CategoryView;
import ca.mcgill.cs.swevo.diffcat.view.ClassSigNode;
import ca.mcgill.cs.swevo.diffcat.view.DiffCatNode;
import ca.mcgill.cs.swevo.diffcat.view.FieldSigNode;
import ca.mcgill.cs.swevo.diffcat.view.MethodSigNode;

public class CompareAction extends DiffCatAction {

	public CompareAction (CategoryView viewHandle) {
		super (viewHandle);
	}
	
	public void run() {
		
		ISelection selection = view.getTreeSelection();
		Object obj = ((IStructuredSelection)selection).getFirstElement();
		
		if (obj instanceof DiffCatNode) {
			DiffCatNode r = (DiffCatNode) obj;
			view.compareDiffInEditor(r.getResult());
		}
		else if (obj instanceof ClassSigNode) 
		{
			ClassSigNode c = (ClassSigNode) obj;
			view.compareNodeInEditor(c);
		}
		else if (obj instanceof MethodSigNode) 
		{
			MethodSigNode m = (MethodSigNode) obj;
			view.compareNodeInEditor(m);
		}
		else if (obj instanceof FieldSigNode) 
		{
			FieldSigNode f = (FieldSigNode) obj;
			view.compareNodeInEditor(f);
		}
		
	}
}
