/*******************************************************************************
 * SemDiff
 * Copyright (C) 2008 Barthelemy Dagenais
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this library. If not, see 
 * <http://www.gnu.org/licenses/lgpl-3.0.txt>
 *******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.view.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.ui.PlatformUI;

import ca.mcgill.cs.swevo.diffcat.view.CategoryView;
import ca.mcgill.cs.swevo.semdiff.internal.ui.views.TransactionsView;

public class GotoTransactionAction extends Action {

	private CategoryView view;
	
	public GotoTransactionAction(CategoryView view) {
		super();
		this.view = view;
	}

	@Override
	public void run() {
		InputDialog iDialog = new InputDialog(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),"Enter transaction id","Enter transaction id","",null);
		if (iDialog.open() == InputDialog.OK) {
			String input = iDialog.getValue();
			view.changeTransaction(Integer.parseInt(input));
		}
		
	}

	
	
}
