/*******************************************************************************
 * SemDiff
 * Copyright (C) 2008 Barthelemy Dagenais
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this library. If not, see 
 * <http://www.gnu.org/licenses/lgpl-3.0.txt>
 *******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.view.actions;

import org.eclipse.jface.action.Action;

import ca.mcgill.cs.swevo.diffcat.view.CategoryView;
import ca.mcgill.cs.swevo.semdiff.core.Repository;
import ca.mcgill.cs.swevo.semdiff.core.Transaction;
import ca.mcgill.cs.swevo.semdiff.internal.ui.views.TransactionsView;
import ca.mcgill.cs.swevo.semdiff.ui.UIActivator;

public class NextTransactionAction extends Action {

	private CategoryView view;
	
	public NextTransactionAction(CategoryView view) {
		super();
		this.view = view;
//		setActionDefinitionId("ca.mcgill.cs.swevo.diffcat.view.actions.nextTransaction");
		setImageDescriptor(UIActivator.imageDescriptorFromPlugin(UIActivator.PLUGIN_ID, "icons/forward_nav.gif"));
		setToolTipText("Next Transaction");
	}

	@Override
	public void run() {
		if (view != null) {
			Transaction t = view.getCurrentTransaction();
			Repository r = view.getCurrentRepository();
			int newIndex = t != null ? t.getId() + 1 : -1;
			if (newIndex >= 0 && r != null && newIndex < r.getTransactionsSize()) {
				view.changeTransaction(newIndex);
			}
		}
	}


}
