package ca.mcgill.cs.swevo.diffcat.view.diff;

import java.io.ByteArrayInputStream;
import java.io.InputStream;

import org.eclipse.compare.IStreamContentAccessor;
import org.eclipse.compare.ITypedElement;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.swt.graphics.Image;

class ByteChunk implements IStreamContentAccessor, ITypedElement {
	
	private byte[] content; 
	private String name;
	private String type;
	private Image image;
	
	public ByteChunk (byte[] content, String name, String type, Image image) {
		this.content = content;
		this.name = name;
		this.type = type;
		this.image = image;
	}

	@Override
	public InputStream getContents() throws CoreException {
		return new ByteArrayInputStream(content);
	}

	@Override
	public Image getImage() {
		return image;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public String getType() {
		return type;
	}
	
	// XXX To get Differencer to compare two byte chunks
	public boolean equals (Object o) {
		
		if (o == this) {
			return true;
		}
		
		if (o == null || ! o.getClass().equals(this.getClass())) {
			return false;
		}
		
		ByteChunk other = (ByteChunk) o;
		
		return other.getName().equals(getName());
	}
	
	public int hashCode () {
		return getName().hashCode();
	}
}
