package ca.mcgill.cs.swevo.diffcat.view.filters;

import ca.mcgill.cs.swevo.diffcat.model.DiffCatResult;
import ca.mcgill.cs.swevo.diffcat.view.diff.DiffShell;
import ca.mcgill.cs.swevo.util.filter.IFilter;

public class EnclosesShellFilter implements IFilter<DiffShell> {

	private DiffCatResult result;
	
	public EnclosesShellFilter (DiffCatResult result) {
		this.result = result;
	}

	@Override
	public boolean passesFilter(DiffShell diff) {
		if (result.isDelete()) {
			return result.leftEncloses(diff.leftOff, diff.leftLen);
		} else if (result.isInsert()) {
			return result.rightEncloses(diff.rightOff, diff.rightLen);
		} else if (result.isMove() || result.isUpate()) {
			return result.leftEncloses(diff.leftOff, diff.leftLen) &&
					result.rightEncloses(diff.rightOff, diff.rightLen);
		} else {
			return false;
		}
	}
}
