package ca.mcgill.cs.swevo.diffcat.view.filters;

import ca.mcgill.cs.swevo.diffcat.model.DiffCatResult;
import ca.mcgill.cs.swevo.diffcat.view.diff.DiffShell;
import ca.mcgill.cs.swevo.util.filter.IFilter;

public class InRangeOfShellFinder implements IFilter<DiffShell> {

	private DiffCatResult result;
	
	public InRangeOfShellFinder (DiffCatResult result) {
		this.result = result;
	}
	
	@Override
	public boolean passesFilter(DiffShell t) {
		return isInRange (result, t);
	}
	
	private boolean isInRange (DiffCatResult result, DiffShell diff)
	{
		if (result.isDelete()) {
			return result.isLeftInRange(diff.leftOff, diff.leftLen);
		} else if (result.isInsert()) {
			return result.isRightInRange(diff.rightOff, diff.rightLen);
		} else if (result.isMove() || result.isUpate()) {
			return result.isLeftInRange(diff.leftOff, diff.leftLen) &&
					result.isRightInRange(diff.rightOff, diff.rightLen);
		} else {
			return false;
		}
	}

}
