package ca.mcgill.cs.swevo.diffcat.view.preferences;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import ca.mcgill.cs.swevo.diffcat.view.Activator;

public class DiffCatFilterPrefPage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {

	public DiffCatFilterPrefPage() {
		super(GRID);
		setPreferenceStore(Activator.getDefault().getPreferenceStore());
		setDescription("A demonstration of a preference page implementation");
	}
	
	/**
	 * Creates the field editors. Field editors are abstractions of
	 * the common GUI blocks needed to manipulate various types
	 * of preferences. Each field editor knows how to save and
	 * restore itself.
	 */
	public void createFieldEditors() {
		
		addField(
			new BooleanFieldEditor(
					PreferenceConstants.P_FILTER_SHOW_FIELD_RENAMES,
					"Show field renames",
					getFieldEditorParent()));
		addField(
			new BooleanFieldEditor(
					PreferenceConstants.P_FILTER_SHOW_METHOD_RENAMES,
					"Show method renames",
					getFieldEditorParent()));
		addField(
			new BooleanFieldEditor(
					PreferenceConstants.P_FILTER_SHOW_PARAM_RENAMES,
					"Show param renames",
					getFieldEditorParent()));
		addField(
			new BooleanFieldEditor(
					PreferenceConstants.P_FILTER_SHOW_VARIABLE_RENAMES,
					"Show variable renames",
					getFieldEditorParent()));
		addField(
			new BooleanFieldEditor(
					PreferenceConstants.P_FILTER_SHOW_RENAME_INDUCED,
					"Show rename-induced differences",
					getFieldEditorParent()));
		addField(
			new BooleanFieldEditor(
					PreferenceConstants.P_FILTER_SHOW_TRIVIAL_THIS,
					"Show trivial this expression updates",
					getFieldEditorParent()));
		addField(
			new BooleanFieldEditor(
					PreferenceConstants.P_FILTER_SHOW_TRIVIAL_IF,
					"Show trivial if statement updates",
					getFieldEditorParent()));
		addField(
			new BooleanFieldEditor(
					PreferenceConstants.P_FILTER_SHOW_DOCUMENT_DIFFS,
					"Show documentation differences",
					getFieldEditorParent()));
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}

}
