/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat;

import java.net.URL;

import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;

import ca.mcgill.cs.swevo.semdiff.core.AbstractLabelProvider;
import ca.mcgill.cs.swevo.semdiff.core.Result;
import ca.mcgill.cs.swevo.diffcat.model.DiffCatResult;

public class DiffCatLabelProvider extends AbstractLabelProvider {
	 
	@Override
	public Image getImage(Object element) {
		Result result = (Result) element;

		if (result.getHandleFrom() == null && result.getHandleTo() != null) {
			return getImage("icons/add.gif");
		} else if (result.getHandleFrom() != null && result.getHandleTo() == null) {
			return getImage("icons/remove.gif");
		} else {
			return getImage("icons/synced.gif");
		}
		
	}

	private Image getImage (String path) {
		URL url = FileLocator.find(Activator.getDefault().getBundle(), Path.fromOSString(path), null);
		return ImageDescriptor.createFromURL(url).createImage();
	}
	
	@Override
	public String getText(Object element) {
		DiffCatResult result = (DiffCatResult) element;
		return result.toString();
	}

}
