/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.analysis;

import java.util.Set;

import ca.mcgill.cs.swevo.diffcat.model.DiffCatResult;
import ca.mcgill.cs.swevo.util.CollectionMap;

public interface ISimilarityScorer {

	public double getSimilarityScore (DiffCatResult delete, DiffCatResult insert, Set<DiffCatResult> knowns);
	
	public void trimCandidateMap (CollectionMap<DiffCatResult, DiffCatResult> candidates, Set<DiffCatResult> knowns);
}
