/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.cd.finder;

import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.BreakStatement;
import org.eclipse.jdt.core.dom.ContinueStatement;
import org.evolizer.changedistiller.model.entities.SourceCodeEntity;

public class ContinueStatementFinder extends ANodeFinder  {

	private final ASTNode methodDecl;
	private boolean stopVisiting;
	
	public ContinueStatementFinder (SourceCodeEntity statement, ASTNode methodDecl) {
		this.methodDecl = methodDecl;
		this.stopVisiting = false;
	}
	
	public boolean visit(ContinueStatement s) {
		
		if (stopVisiting) {
			return false;
		}
		
		if (! super.inCorrectMethodDecl(s, methodDecl)) {
			return false;
		}
		
		stopVisiting = true;
		super.assocNode = s;
		return false;
	}

}
