/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.util.binding;

import org.eclipse.jdt.core.dom.IBinding;

import ca.mcgill.cs.swevo.util.filter.IFilter;

public class IsVariableBindingFilter implements IFilter<IBinding> {
	
	private IsVariableBindingFilter () {
		
	}
	
	@Override
	public boolean passesFilter(IBinding t) {
		if (t == null || t.getKind() != IBinding.VARIABLE) {
			return false;
		} 
		return true;
	}
	
	public static final IsVariableBindingFilter filter = new IsVariableBindingFilter();
}
