/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.util.binding;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.dom.IAnnotationBinding;
import org.eclipse.jdt.core.dom.IBinding;
import org.eclipse.jdt.core.dom.IMethodBinding;
import org.eclipse.jdt.core.dom.ITypeBinding;
import org.eclipse.jdt.core.dom.IVariableBinding;

public class FakeVariableBinding implements IVariableBinding {

	private String name = "default";
	private ITypeBinding declClass = null;
	private IMethodBinding declMethod = null;
	private ITypeBinding varType = FakeTypeBinding.getObjectTypeBinding();
	
	public void setName (String name) {
		this.name = name;
	}
	
	public void setDeclaringClass (ITypeBinding declaringType) {
		this.declClass = declaringType;
	}
	
	public void setDeclaringMethod (IMethodBinding declaringMethod) {
		this.declMethod = declaringMethod;
	}
	
	public void setType (ITypeBinding type) {
		this.varType = type;
	}
	
	@Override
	public String toString () {
		return getName();
	}
	
	@Override
	public IAnnotationBinding[] getAnnotations() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IJavaElement getJavaElement() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getKey() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getKind() {
		return IBinding.VARIABLE;
	}

	@Override
	public int getModifiers() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public boolean isDeprecated() {
		return false;
	}

	@Override
	public boolean isEqualTo(IBinding arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isRecovered() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isSynthetic() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public Object getConstantValue() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding getDeclaringClass() {
		return declClass;
	}

	@Override
	public IMethodBinding getDeclaringMethod() {
		return declMethod;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public ITypeBinding getType() {
		return varType;
	}

	@Override
	public IVariableBinding getVariableDeclaration() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getVariableId() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public boolean isEnumConstant() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isField() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isParameter() {
		// TODO Auto-generated method stub
		return false;
	}

}
