/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.util.binding;

import junit.framework.Assert;

import org.eclipse.jdt.core.dom.ITypeBinding;
import org.junit.Before;
import org.junit.Test;

import ca.mcgill.cs.swevo.diffcat.util.binding.BindingUtil;

public class TestBindingUtil {

	private FakeTypeBinding t01;
	private FakeTypeBinding t02;
	
	@Before 
	public void build () 
	{
		t01 = new FakeTypeBinding();
		t01.setPackage("java.lang");
		t01.setName("String");
		
		t02 = new FakeTypeBinding();
		t02.setPackage("fake.package");
		t02.setName("String");
	}
	
	@Test 
	public void testSameTypeDiffPackage () 
	{
		Assert.assertFalse(BindingUtil.areEqual(t01, t02));
	}
	
	@Test
	public void testSymmetricEquality ()
	{
		FakeTypeBinding t01 = new FakeTypeBinding();
		
		Assert.assertTrue(BindingUtil.areEqual(t01, t01));
	}
}
