/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.util;

import java.util.List;

public class ArrayUtil {

	/**
	 * Utility method for arrays
	 */
	public static <T> int indexOf (T[] array, T element) {
		for (int i = 0; i < array.length; i++) {
			if (array[i].equals(element)) {
				return i;
			}
		}
		
		return -1;
	}

	/**
	 * Utility method for arrays and lists.
	 */
	public static <T> void addAll (T[] array, List<T> collection) {
		for (T item : array) {
			collection.add(item);
		}
	}

	/**
	 * Utility method for arrays and lists
	 */
	public static <T> boolean areEqual (T[] array, List<T> list) {
		if (array.length != list.size()) {
			return false;
		}
		for (int i = 0; i < array.length; i++) {
			if (! array[i].equals(list.get(i))) {
				return false;
			}
		}
		return true;
	}

}
