/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.util;

public class LCRTuple <T> {

	private T left;
	private T center;
	private T right;
	
	public LCRTuple (T left, T center, T right) {
		this.left = left;
		this.center = center;
		this.right = right;
	}
	
	public T getLeft () {
		return left;
	}
	
	public void setLeft (T left) {
		this.left = left;
	}
	
	public T getRight () {
		return right;
	}
	
	public void setRight (T right) {
		this.right = right;
	}
	
	public void setCenter (T center) {
		this.center = center;
	}
	
	public T getCenter () {
		return center;
	}
	
	public boolean equals (Object o) {
		if (o == this) {
			return true; 
		}
		if (o == null) {
			return false;
		}
		if (! o.getClass().equals(getClass())) {
			return false;
		}
		
		LCRTuple tuple = (LCRTuple) o;
		
		Object left = tuple.getLeft();
		Object right = tuple.getRight();
		Object center = tuple.getCenter();
		
		if (! equals(left, getLeft())) {
			return false;
		}
		
		if (! equals(right, getRight())) {
			return false;
		}
		
		if (! equals(center, getCenter())) {
			return false;
		}
		
		return true;
	}
	
	private boolean equals (Object one, Object two) {
		if (one == null) {
			if (two == null) {
				return true;
			} else {
				return false;
			}
		}
		else
		{
			if (two == null) {
				return false;
			} else {
				return one.equals(two);
			}
		}
	}
	
	@Override
	public int hashCode () {
		T left = getLeft();
		T right = getRight();
		T center = getCenter();
		return hashCode(left) * hashCode(center) * hashCode(right);  
	}
	
	private int hashCode (T element) {
		return element != null ? element.toString().hashCode() : 1;
	}
	
	@Override
	public String toString () {
		return toString(left) + " " + toString(center) + " " + toString(right);  
	}
	
	private String toString (T element) {
		return element != null ? element.toString() : "";
	}
}
