/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.util;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

public class LRTupleCollection <T> implements Iterable<LRTuple<T>>{

	private final Collection<LRTuple<T>> collection;
	
	public LRTupleCollection () {
		this.collection = new LinkedList<LRTuple<T>>();
	}

	public void add (T left, T right) {
		collection.add(new LRTuple<T>(left, right));
	}
	
	@Override
	public Iterator<LRTuple<T>> iterator() {
		return collection.iterator();
	}
	
	public boolean isEmpty () {
		return collection.isEmpty();
	}
	
	public int size () {
		return collection.size();
	}
}
 
